﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OkstraI18NTranslation;

namespace OKSTRAnslatorInstanceLevel
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Count() == 2)
            {
                magic(args[0], args[1]);
            }
            else
            {
                //string filename = @"C:\Users\Julian\Desktop\OKSTRA Korea\AxisGerman.xml";

                magic(@"E:\dev\OkstraI18N\ExamplesGerman\ex-horizontal-alignment.xml", @"E:\dev\OkstraI18N\ExamplesEnglish\ex-horizontal-alignment.xml");
                magic(@"E:\dev\OkstraI18N\ExamplesGerman\ex-terrain-alignment.xml", @"E:\dev\OkstraI18N\ExamplesEnglish\ex-terrain-alignment.xml");
                magic(@"E:\dev\OkstraI18N\ExamplesGerman\ex-terrain-surface.xml", @"E:\dev\OkstraI18N\ExamplesEnglish\ex-terrain-surface.xml");
                magic(@"E:\dev\OkstraI18N\ExamplesGerman\vertical-alignment.xml", @"E:\dev\OkstraI18N\ExamplesEnglish\vertical-alignment.xml");
            }
        }

        static void magic(string sourceFilename, string destFilename)
        {
            System.IO.StreamReader reader;
            StreamWriter translatedFilename;

            try
            {
                reader = new System.IO.StreamReader(sourceFilename, Encoding.GetEncoding("iso-8859-1"));
                translatedFilename = new StreamWriter(destFilename);
            }
            catch(Exception e)
            {
                Console.WriteLine(e.Message);
                return;
            }

            List<TranslationSubstring> translationSubstrings = new List<TranslationSubstring>();
            translationSubstrings = TranslationSubstring.getOkstraTranslationSubstrings();

            while (!reader.EndOfStream)
            {
                var line = reader.ReadLine();

                if (line == "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>")
                {
                    translatedFilename.WriteLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
                    continue;
                }

                if (line == "<!-- generiert von OKLABI, (c) 2009-2016 Bundesanstalt für Straßenwesen -->")
                {
                    translatedFilename.WriteLine("<!-- generated by TUM Open Infra Platform, based on OKLABI (c) 2009-2016 Bundesanstalt für Straßenwesen -->");
                    continue;
                }

                foreach (var ts in translationSubstrings)
                {
                    if (line.Contains(ts.GermanSubstring))
                    {
                        line = line.Replace(ts.GermanSubstring, ts.EnglishSubstring);
                    }
                }

                translatedFilename.WriteLine(line);
            }

            translatedFilename.Close();
        }
    }
}
