﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using OkstraI18NTranslation;

using Excel = Microsoft.Office.Interop.Excel;

namespace TranslationSubstringEditor
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UpdateTranslationSubstringListBox();
        }

        private void UpdateTranslationSubstringListBox()
        {
            listBoxTranslationSubstrings.Items.Clear();

            foreach (TranslationSubstring ts in tsl)
            {
                listBoxTranslationSubstrings.Items.Add(ts.GermanSubstring);
            }
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            tsl.Add(new TranslationSubstring(textBoxGerman.Text, textBoxEnglish.Text));

            UpdateTranslationSubstringListBox();
        }

        List<TranslationSubstring> tsl = OkstraI18NTranslation.TranslationSubstring.getOkstraTranslationSubstrings();

        private void buttonGenerateCode_Click(object sender, EventArgs e)
        {
            string generatedCode = "";

            foreach(var x in tsl)
            {
                generatedCode += "ts.Add(new TranslationSubstring(\"" + 
                    x.GermanSubstring.Replace("\"", "\\\"") + 
                    "\", \"" + 
                    x.EnglishSubstring.Replace("\"", "\\\"") + "\"));";
                generatedCode += Environment.NewLine;
            }

            textBoxGeneratedCode.Text = generatedCode;
        }

        private void buttonExcelImport_Click(object sender, EventArgs e)
        {
            Excel.Workbook MyBook = null;
            Excel.Application MyApp = null;
            Excel.Worksheet MySheet = null;

            MyApp = new Excel.Application();
            MyApp.Visible = false;
            string DB_PATH = @"C:\dev\OkstraI18N\Übersetzung.xlsx";
            MyBook = MyApp.Workbooks.Open(DB_PATH);
            MySheet = (Excel.Worksheet)MyBook.Sheets[1]; // Explicit cast is not required here
            var lastRow = MySheet.Cells.SpecialCells(Excel.XlCellType.xlCellTypeLastCell).Row;

            for (int index = 452; index <= lastRow; index++)
            {
                try
                {
                    System.Array MyValues = (System.Array)MySheet.get_Range("A" +
                                 index.ToString(), "B" + index.ToString()).Cells.Value;

                    string german = MyValues.GetValue(1, 1).ToString();
                    string english = MyValues.GetValue(1, 2).ToString();
                    TranslationSubstring ts = new TranslationSubstring(german, english);
                    tsl.Add(ts);
                }
                catch(Exception ex)
                {

                }
            }
        }
    }
}
