﻿using System;
using System.Xml;
using System.Xml.Schema;

class XmlSchemaSetExample
{
    static void Main()
    {
        XmlReaderSettings settings = new XmlReaderSettings();
        settings.Schemas.Add("http://www.okstra.de/okstra/2.017", @"C:\dev\OkstraI18N\SchemaGerman\okstra.xsd");
        settings.ValidationType = ValidationType.Schema;
        settings.ValidationEventHandler += new ValidationEventHandler(okstraSettingsValidationEventHandler);

        XmlReader okstraReader = XmlReader.Create(@"C:\dev\OkstraI18N\ExamplesGerman\ex-horizontal-alignment.xml", settings);

        while (okstraReader.Read()) { }
    }

    static void okstraSettingsValidationEventHandler(object sender, ValidationEventArgs e)
    {
        if (e.Severity == XmlSeverityType.Warning)
        {
            Console.Write("WARNING: ");
            Console.WriteLine(e.Message);
        }
        else if (e.Severity == XmlSeverityType.Error)
        {
            Console.Write("ERROR: ");
            Console.WriteLine(e.Message);
        }
    }
}



